    
;===================================================================
;                   MAIN.ASM
;       sets BL =1, AX = 555H 
;       calls Reseed
;	Calls Rand 100 times w/ lower=0 upper = 9999
;	Prints values 10 numbers/line and 6 ch/number and right justify
;	Counts low values (0-4999) and high values (5000-9999) 
;	Counts evens and odds
;	Sets BL=0
;	Calls Reseed
;	Calls Rand 100 times w/ lower=0 upper = 9999
;	Prints values 10 numbers/line and 6 ch/number and right justify
;	Counts low values (0-4999) and high values (5000-9999) 
;	Counts evens and odds
;	Prints statistics (#/200)
;	
;===================================================================
                EXTERN   GETDEC:FAR
                EXTERN   NEWLINE:FAR
                EXTERN   PUTDEC:FAR
                EXTERN   PUTSTRNG:FAR
;==================================================================
           .MODEL  COMPACT,BASIC
;===================================================================
	   .STACK 256
;===================================================================
; D A T A   S E G M E N T   D E F I N I T I O N
            .FARDATA MAIN_DATA
HIGHCOUNT	DW	0	
LOWCOUNT	DW	0
EVENCOUNT	DW	0	
ODDCOUNT	DW	0
HIGHHEADER	DB	'High numbers: '
LOWHEADER	DB	'Low numbers: '
ODDHEADER	DB	'Odd numbers: '
EVENHEADER	DB	'Even numbers: '
;===================================================================
; C O D E   S E G M E N T   D E F I N I T I O N
;
           .CODE
	   EXTERN  RANDOM : FAR, RESEED : FAR
           ASSUME  DS:NOTHING,ES:MAIN_DATA

MAIN       PROC
	   MOV     AX,DGROUP           ;SET ES-REGISTER TO POINT TO
           MOV     ES,AX               ;CONSTANT DATA SEGMENT

	   MOV	   BL,1
	   CALL	   RESEED
           MOV     CX,100              ;   LOOP_COUNT = 100
NUM_LOOP:                              ;   REPEAT
           PUSH    CX                  ;      PUSH LOOP_COUNT


           MOV	   AX,0                ;PUSH LOWER
           PUSH    AX             
           MOV     AX,0000             ;PUSH UPPER
           PUSH AX 
	   CALL RANDOM
    
	   CALL    PUTDEC
	   CALL    NEWLINE             ;DISPLAY NEWLINE CHAR.
	   CMP	   AX, 5000
	   JGE 	   HIGH_SEQUENCE
	   INC	    LOWCOUNT
HIGH_SEQUENCE:
	   INC HIGHCOUNT
           SUB     DX, DX
           MOV     BX, 2
           DIV     BX
           CMP     DX, 0
           JNE     ODDS
	   INC	   EVENCOUNT
ODDS:
	   INC	   ODDCOUNT          
           POP     CX                  ;      POP LOOP_COUNT
           INC     AX                  ;      NUMBER = NUMBER + 1
           LOOP    NUM_LOOP            ;      DECREMENT LOOP_COUNT
                                       ;   UNTIL LOOP_COUNT = 0 



	   ;MOV	   0,BL
	   ;CALL	   RESEED

                LEA     DI, HIGHHEADER
                MOV     CX, 18
                CALL    PUTSTRNG
		CALL    NEWLINE                
MAIN       ENDP                     
           END		MAIN
